# TODO
# - see and adopt: http://gist.github.com/359890
%define		plugin	check_raid
Summary:	Nagios plugin to check current server's RAID status
Name:		nagios-plugin-%{plugin}
Version:	3.2.2
Release:	1
License:	GPL v2
Group:		Networking
Source0:	https://github.com/glensc/nagios-plugin-check_raid/archive/%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	27ceddf21ddc20ec636716ec1f581596
URL:		https://github.com/glensc/nagios-plugin-check_raid
BuildRequires:	rpmbuild(macros) >= 1.685
Requires:	grep
Requires:	nagios-common
Requires:	perl-base >= 1:5.8.0
Requires:	sed >= 4.0
Requires:	sudo >= 1:1.8.7-2
Suggests:	CmdTool2
Suggests:	arcconf
Suggests:	areca-cli
Suggests:	cciss_vol_status
Suggests:	hpacucli
Suggests:	lsscsi
Suggests:	megacli-sas
Suggests:	megarc-scsi
Suggests:	mpt-status
Suggests:	smartmontools
Suggests:	tw_cli-9xxx
# cciss_vol_status 1.10 can process /dev/sdX instead of only /dev/sgX
Conflicts:	cciss_vol_status < 1.10
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sysconfdir	/etc/nagios/plugins
%define		nrpeddir	/etc/nagios/nrpe.d
%define		plugindir	%{_prefix}/lib/nagios/plugins

%description
This plugin chekcs Check all RAID volumes (hardware and software) that
can be identified.

Supports:
- AIX software RAID via lsvg
- Adaptec AAC RAID via aaccli or afacli or arcconf
- Areca SATA RAID Support
- HP Smart Array (MSA1500) via serial line
- HP Smart Array Controllers and MSA Controllers via hpacucli (see
  hapacucli readme)
- HP/Compaq Smart Array via cciss_vol_status (hpsa supported too)
- LSI Logic MegaRAID SAS series via MegaCli
- LSI MegaRaid via lsraid
- Linux 3ware SATA RAID via tw_cli
- Linux DPT/I2O hardware RAID controllers via /proc/scsi/dpt_i2o
- Linux GDTH hardware RAID controllers via /proc/scsi/gdth
- Linux LSI MegaRaid hardware RAID via /proc/megaraid
- Linux LSI MegaRaid hardware RAID via CmdTool2
- Linux LSI MegaRaid hardware RAID via megarc
- Linux MPT hardware RAID via mpt-status
- Linux MegaIDE hardware RAID controllers via /proc/megaide
- Linux software RAID (md) via /proc/mdstat
- SAS2IRCU support
- Serveraid IPS via ipssend
- Solaris software RAID via metastat

%prep
%setup -qc
mv nagios-plugin-check_raid-*/* .

%build
ver=$(./%{plugin}.pl -V)
test "$(echo "$ver" | awk '{print $NF}')" = %{version}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{nrpeddir},%{plugindir}}
install -p %{plugin}.pl $RPM_BUILD_ROOT%{plugindir}/%{plugin}
cp -p %{plugin}.cfg $RPM_BUILD_ROOT%{_sysconfdir}/%{plugin}.cfg
touch $RPM_BUILD_ROOT%{nrpeddir}/%{plugin}.cfg

%clean
rm -rf $RPM_BUILD_ROOT

%post
# setup sudo rules:
# - on first install
# - if separate config file is used
grep -q '^#includedir /etc/sudoers\.d' /etc/sudoers && confd=1

if [ "$1" = 1 -o "$confd" = 1 ]; then
	# setup sudo rules on first install
	%{plugindir}/%{plugin} -S || :
fi

%postun
if [ "$1" = 0 ]; then
	# remove all sudo rules related to us
	%{__sed} -i -e '/CHECK_RAID/d' /etc/sudoers
fi

%triggerpostun -- %{name} < 3.1.1-0.2, sudo < 1:1.8.7-2
if grep -q '^#includedir /etc/sudoers\.d' /etc/sudoers; then
	# setup sudo rules on first install
	%{plugindir}/%{plugin} -S || :
fi
# remove CHECK_RAID rules from /etc/sudoers if separate config is in place
if [ -e /etc/sudoers.d/check_raid ]; then
	%{__sed} -i -e '/CHECK_RAID/d' /etc/sudoers
fi

%triggerin -- nagios-nrpe
%nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg

%triggerun -- nagios-nrpe
%nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg

%files
%defattr(644,root,root,755)
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/%{plugin}.cfg
%attr(755,root,root) %{plugindir}/%{plugin}
%ghost %{nrpeddir}/%{plugin}.cfg
%changelog
* Sat Nov 15 2014 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/nagios-plugin-check_raid.git;a=log;h=master

* Sat Nov 15 2014 Elan Ruusamäe <glen@delfi.ee> d170d56
- up to 3.2.2

* Sun Sep 21 2014 Elan Ruusamäe <glen@delfi.ee> 59ac65d
- up to 3.2.0, migrate sudoers config to separate file

* Thu Sep 11 2014 Elan Ruusamäe <glen@delfi.ee> cdda5f8
- Merge branch 'DEVEL'

* Tue Sep 09 2014 Elan Ruusamäe <glen@delfi.ee> c49666e
- up to 3.1.0; use nrpe trigger

* Tue Jan 28 2014 Elan Ruusamäe <glen@delfi.ee> c04d004
- soft dep on nrpe

* Tue Jan 28 2014 Elan Ruusamäe <glen@delfi.ee> 3745f26
- hook into nrpe.d

* Mon Dec 16 2013 Elan Ruusamäe <glen@delfi.ee> e66d9ca
- up to 3.0.6

* Thu Dec 20 2012 Elan Ruusamäe <glen@delfi.ee> 04e7ecc
- 3.0 from master branch

* Wed Jul 18 2012 Elan Ruusamäe <glen@delfi.ee> bba37da
- up to 2.2.50

* Mon May 28 2012 Elan Ruusamäe <glen@pld-linux.org> eb3c08b
- up to 2.2, project moved to github

* Mon Mar 12 2012 Elan Ruusamäe <glen@pld-linux.org> a0df8e5
- up to 2.1.1.113, check disks for cciss/hpmsa with smartctl

* Tue Jan 31 2012 Elan Ruusamäe <glen@pld-linux.org> 94679d3
- up to 2.1.1.105. most significant change is hpsa devs via cciss_vol_status

* Tue Sep 13 2011 Elan Ruusamäe <glen@pld-linux.org> c1a6298
- include cvs rev in package version

* Mon Apr 18 2011 Elan Ruusamäe <glen@pld-linux.org> 1cdbcc3
- rel 13, a patch to afacli

* Mon Nov 22 2010 Elan Ruusamäe <glen@pld-linux.org> 0bd43c6
- release 12

* Mon Nov 22 2010 Elan Ruusamäe <glen@pld-linux.org> 047af81
- update supported devices list

* Sun Aug 22 2010 Elan Ruusamäe <glen@pld-linux.org> 58d1442
- plugin path expanded already

* Wed Apr 14 2010 Elan Ruusamäe <glen@pld-linux.org> 6aac77a
- blind code for MegaCli support

* Tue Apr 13 2010 Elan Ruusamäe <glen@pld-linux.org> d0095ef
- linux md updates, shows now resync status; rel 11

* Thu Apr 08 2010 Elan Ruusamäe <glen@pld-linux.org> d207195
- improved mdstat: check for failed spares was broken -- upgrade; rel 10

